select custid
      ,prodname
      ,avg_sales
      ,rank
  from
   (select state
          ,city
          ,customer.custid
          ,prodname
          ,rank() over (partition by prodname order by nvl(avg(amount),0) desc) rank 
          ,avg(amount) avg_sales
     from customer
          ,sales
      where customer.custid = sales.custid
      group by state
            ,city
            ,customer.custid
           ,prodname)
   where prodname like 'ACE TENNIS RACKET%'
     and rank < 3
   order by prodname,rank
/
