select deptno
      ,empno
      ,hiredate
      ,sal
      ,avg(sal) over (partition by deptno
                      order by hiredate
                      range between interval '10' month preceding
                                and interval '10' month following) thirty_day
   from emp
   order by deptno,hiredate,empno
/
