select deptno
      ,empno
      ,hiredate
      ,sal
      ,avg(sal) over (partition by deptno
                      order by hiredate
                      range between interval '3' month preceding
                                and interval '3' month following) three_mon
      ,first_value(sal) over (partition by deptno
                      order by hiredate
                      range between interval '3' month preceding
                                and interval '3' month following) first_val
      ,last_value(sal) over (partition by deptno
                      order by hiredate
                      range between interval '3' month preceding
                                and interval '3' month following) last_val
   from emp
   order by deptno,hiredate,empno
/
